import {Group, groupData} from './export/group';
import {User, userData} from './export/user';
import colors from 'colors';

function test_wrapper(func: string, cond: boolean) {
    console.log(colors.blue("Test de "+func+"..."));
    try {
        if (cond) console.log(colors.green("Test passé avec succès !"));
        else      console.log(colors.yellow("Erreur bizarre"));
    }
    catch {
        console.log(colors.red("Echec catastrophique !"));
        return;
    }
}

// Tests simples et naïfs sur les groupes seuls
async function test_Group() {
    let test_data = new groupData();
    test_data.name = "test_group";
    test_wrapper("Group.search", (await Group.search(test_data)).length == 0);
    test_wrapper("Group.create", await Group.create(test_data) && await Group.search(test_data)[0] == test_data.gid);
    console.log(colors.underline("top level post search"));
    console.log(test_data);
    test_wrapper("Group.peek", await Group.peek(test_data.gid) == test_data);
    test_data.admins=["quentin.chevalier"];
    test_wrapper("Group.addAdmin", await Group.addAdmin(test_data.gid, "quentin.chevalier") && await Group.peek(test_data.gid) == test_data);
    test_data.admins=[];
    test_wrapper("Group.remAdmin", await Group.remAdmin(test_data.gid, "quentin.chevalier") && await Group.peek(test_data.gid) == test_data);
    test_data.speakers=["quentin.chevalier"];
    test_wrapper("Group.addSpeaker", await Group.addSpeaker(test_data.gid, "quentin.chevalier") && await Group.peek(test_data.gid) == test_data);
    test_data.speakers=[];
    test_wrapper("Group.remSpeaker", await Group.remSpeaker(test_data.gid, "quentin.chevalier") && await Group.peek(test_data.gid) == test_data);
    test_data.members=["quentin.chevalier"];
    test_wrapper("Group.addMember", await Group.addMember(test_data.gid, "quentin.chevalier") && await Group.peek(test_data.gid) == test_data);
    test_data.members=[];
    test_wrapper("Group.remMember", await Group.remMember(test_data.gid, "quentin.chevalier") && await Group.peek(test_data.gid) == test_data);
    test_data.followers=["quentin.chevalier"];
    test_wrapper("Group.addFollower", await Group.addFollower(test_data.gid, "quentin.chevalier") && await Group.peek(test_data.gid) == test_data);
    test_data.followers=[];
    test_wrapper("Group.remFollower", await Group.remFollower(test_data.gid, "quentin.chevalier") && await Group.peek(test_data.gid) == test_data);
    test_data.name="test_group2";
    test_wrapper("Group.edit", await Group.edit(test_data) && await Group.peek(test_data.gid) == test_data);
    test_wrapper("Group.delete", await Group.delete(test_data.gid) &&  (await Group.search(test_data)).length == 0);
}

async function main() {
    test_Group();
}

main()